
/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * wfb.c - Win-Fix-Bug sample program
 *
 * Demonstrates how to set a patch a program in memory.
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * (c) Copyright Third Eye Software 1996-7.  All rights reserved.
 * http://www.escape.com/~eye3/
 *
 */

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <stdio.h>
#include <windows.h>
#include <fixbug.h>

int main(int argc, char *argv[])
{
  char *pszCommand = "main.exe";
  unsigned char newb[] = { 0xff, 0xd }; /* opcode for dec */
  unsigned char expb[] = { 0xff, 0x5 }; /* opcode for inc */
  
  if (!FixBugInit()) {
    printf("Could not initialize Win-Fix-Bug (%s)\n",
	   FBErrorStr(FBGetLastError()));
    return 1;
  }

  PatchBytes(pszCommand, NULL, "increment_j", 6, newb, sizeof(newb), expb);
  FixBugRun(pszCommand, NULL, FBR_REUSE_CONSOLE);

  return 0;
}

